---
title: Multi-touch interaction
slug: Web/API/Pointer_events/Multi-touch_interaction
tags:
  - Guide
  - Pointer Events
  - touch
---
<p>{{DefaultAPISidebar("Pointer Events")}}</p>

<p>Pointer events extend DOM input events to support various pointing input devices such as pen/stylus and touch screens as well as mouse. The <em>pointer</em> is a hardware-agnostic device that can target a specific set of screen coordinates. Having a single event model for pointers can simplify creating Web sites, applications and provide a good user experience regardless of the user's hardware.</p>

<p>Pointer events have many similarities to mouse events but they support multiple simultaneous pointers such as multiple fingers on a touch screen. This additional feature can be used to provide richer user interaction models but at the cost of additional complexity in the multi-touch interaction handling. This document demonstrates via example code, using pointer events with different multi-touch interactions.</p>

<p>A <em>live</em> version of this application is available on <a href="https://mdn.github.io/dom-examples/pointerevents/Multi-touch_interaction.html">Github</a>. The <a href="https://github.com/mdn/dom-examples/blob/master/pointerevents/Multi-touch_interaction.html">source code is available on Github</a>; pull requests and <a href="https://github.com/mdn/dom-examples/issues">bug reports</a> are welcome.</p>

<h2 id="Example">Example</h2>

<p>This example demonstrates using pointer events' various event types ({{event("pointerdown")}}, {{event("pointermove")}}, {{event("pointerup")}} {{event("pointercancel")}}, etc.) for different multi-touch interactions.</p>

<h3 id="Define_touch_targets">Define touch targets</h3>

<p>The application uses {{HTMLElement("div")}} to define three different touch target areas.</p>

<pre class="brush: html">&lt;style&gt;
  div {
    margin: 0em;
    padding: 2em;
  }
  #target1 {
    background: white;
    border: 1px solid black;
  }
  #target2 {
    background: white;
    border: 1px solid black;
  }
  #target3 {
    background: white;
    border: 1px solid black;
  }
&lt;/style&gt;
</pre>

<h3 id="Global_state">Global state</h3>

<p>To support multi-touch interaction, preserving a pointer's event state during various event phases is required. This application uses three arrays to cache event state, one cache per target element.</p>

<pre class="brush: js">// Log events flag
var logEvents = false;

// Event caches, one per touch target
var evCache1 = new Array();
var evCache2 = new Array();
var evCache3 = new Array();
</pre>

<h3 id="Register_event_handlers">Register event handlers</h3>

<p>Event handlers are registered for the following pointer events: {{event("pointerdown")}}, {{event("pointermove")}} and {{event("pointerup")}}. The handler for {{event("pointerup")}} is used for the {{event("pointercancel")}}, {{event("pointerout")}} and {{event("pointerleave")}} events, since these four events have the same semantics in this application.</p>

<pre class="brush: js">function set_handlers(name) {
 // Install event handlers for the given element
 var el=document.getElementById(name);
 el.onpointerdown = pointerdown_handler;
 el.onpointermove = pointermove_handler;

 // Use same handler for pointer{up,cancel,out,leave} events since
 // the semantics for these events - in this app - are the same.
 el.onpointerup = pointerup_handler;
 el.onpointercancel = pointerup_handler;
 el.onpointerout = pointerup_handler;
 el.onpointerleave = pointerup_handler;
}

function init() {
 set_handlers("target1");
 set_handlers("target2");
 set_handlers("target3");
}
</pre>

<h3 id="Pointer_down">Pointer down</h3>

<p>The {{event("pointerdown")}} event is fired when a pointer (mouse, pen/stylus or touch point on a touchscreen) makes contact with the <em>contact surface</em>. The event's state must be cached, in case this down event is part of a multi-touch interaction.</p>

<p>In this application, when a pointer is placed down on an element, the background color of the element changes, depending on the number of active touch points the element has. See the <code><a href="#Update_background_color">update_background</a></code> function for more details about the color changes.</p>

<pre class="brush: js">function pointerdown_handler(ev) {
 // The pointerdown event signals the start of a touch interaction.
 // Save this event for later processing (this could be part of a
 // multi-touch interaction) and update the background color
 push_event(ev);
 if (logEvents) log("pointerDown: name = " + ev.target.id, ev);
 update_background(ev);
}
</pre>

<h3 id="Pointer_move">Pointer move</h3>

<p>The {{event("pointermove")}} handler is called when the pointer moves. It may be called multiple times (for example, if the user moves the pointer) before a different event type is fired.</p>

<p>In this application, a pointer move is represented by the target's border being set to <code>dashed</code> to provide a clear visual indication that the element has received this event.</p>

<pre class="brush: js">function pointermove_handler(ev) {
 // Note: if the user makes more than one "simultaneous" touch, most browsers
 // fire at least one pointermove event and some will fire several pointermoves.
 //
 // This function sets the target element's border to "dashed" to visually
 // indicate the target received a move event.
 if (logEvents) log("pointerMove", ev);
 update_background(ev);
 ev.target.style.border = "dashed";
}
</pre>

<h3 id="Pointer_up">Pointer up</h3>

<p>The {{event("pointerup")}} event is fired when a pointer is raised from the <em>contact surface</em>. When this occurs, the event is removed from the associated event cache.</p>

<p>In this application, this handler is also used for {{event("pointercancel")}}, {{event("pointerleave")}} and {{event("pointerout")}} events.</p>

<pre class="brush: js">function pointerup_handler(ev) {
  if (logEvents) log(ev.type, ev);
  // Remove this touch point from the cache and reset the target's
  // background and border
  remove_event(ev);
  update_background(ev);
  ev.target.style.border = "1px solid black";
}
</pre>

<h3 id="Application_UI">Application UI</h3>

<p>The application uses {{HTMLElement("div")}} elements for the touch areas and provides buttons to enable logging and to clear the log.</p>

<p class="note">To prevent the browser's default touch behavior from overriding this application's pointer handling, the {{cssxref("touch-action")}} property is applied to the {{HTMLElement("body")}} element.</p>

<pre class="brush: html">&lt;body onload="init();" style="touch-action:none"&gt;
 &lt;div id="target1"&gt; Tap, Hold or Swipe me 1&lt;/div&gt;
 &lt;div id="target2"&gt; Tap, Hold or Swipe me 2&lt;/div&gt;
 &lt;div id="target3"&gt; Tap, Hold or Swipe me 3&lt;/div&gt;

 &lt;!-- UI for logging/debugging --&gt;
 &lt;button id="log" onclick="enableLog(event);"&gt;Start/Stop event logging&lt;/button&gt;
 &lt;button id="clearlog" onclick="clearLog(event);"&gt;Clear the log&lt;/button&gt;
 &lt;p&gt;&lt;/p&gt;
 &lt;output&gt;&lt;/output&gt;
&lt;/body&gt;
</pre>

<h3 id="Miscellaneous_functions">Miscellaneous functions</h3>

<p>These functions support the application but aren't directly involved with the event flow.</p>

<h4 id="Cache_management">Cache management</h4>

<p>These functions manage the global event caches <code>evCache1</code>, <code>evCache2</code> and <code>evCache3</code>.</p>

<pre class="brush: js">function get_cache(ev) {
 // Return the cache for this event's target element
 switch(ev.target.id) {
   case "target1": return evCache1;
   case "target2": return evCache2;
   case "target3": return evCache3;
   default: log("Error with cache handling",ev);
 }
}

function push_event(ev) {
 // Save this event in the target's cache
 var cache = get_cache(ev);
 cache.push(ev);
}

function remove_event(ev) {
 // Remove this event from the target's cache
 var cache = get_cache(ev);
 for (var i = 0; i &lt; cache.length; i++) {
   if (cache[i].pointerId == ev.pointerId) {
     cache.splice(i, 1);
     break;
   }
 }
}
</pre>

<h4 id="Update_background_color">Update background color</h4>

<p>The background color of the touch areas will change as follows: no active touches is <code>white</code>; one active touch is <code>yellow</code>; two simultaneous touches is <code>ping</code> and three or more simultaneous touches is <code>lightblue</code>.</p>

<pre class="brush: js">function update_background(ev) {
 // Change background color based on the number of simultaneous touches/pointers
 // currently down:
 //   white - target element has no touch points i.e. no pointers down
 //   yellow - one pointer down
 //   pink - two pointers down
 //   lightblue - three or more pointers down
 var evCache = get_cache(ev);
 switch (evCache.length) {
   case 0:
     // Target element has no touch points
     ev.target.style.background = "white";
     break;
   case 1:
     // Single touch point
     ev.target.style.background = "yellow";
     break;
   case 2:
     // Two simultaneous touch points
     ev.target.style.background = "pink";
     break;
   default:
     // Three or more simultaneous touches
     ev.target.style.background = "lightblue";
 }
}
</pre>

<h4 id="Event_logging">Event logging</h4>

<p>These functions are used send to event activity to the application window (to support debugging and learning about the event flow).</p>

<pre class="brush: js">// Log events flag
var logEvents = false;

function enableLog(ev) {
  logEvents = logEvents ? false : true;
}

function log(name, ev) {
  var o = document.getElementsByTagName('output')[0];
  var s = name + ": pointerID = " + ev.pointerId +
                " ; pointerType = " + ev.pointerType +
                " ; isPrimary = " + ev.isPrimary;
  o.innerHTML += s + "
";
}

function clearLog(event) {
 var o = document.getElementsByTagName('output')[0];
 o.innerHTML = "";
}
</pre>
